//+------------------------------------------------------------------+
//|                                                 Level Sensor.mq4 |
//|                                          Copyright  2005, Sfen. |
//+------------------------------------------------------------------+
//| LevelSensor_TRO_MODIFIED_VERSION                                 |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+

// http://codebase.mql4.com/2109

#property copyright "Copyright  2005, Sfen"
#property indicator_chart_window
// input parameters
extern int MAX_HISTORY = 120;
extern int STEP = 1;
extern double SDVIG=50;


//extern int   ChangeColor = 10;
extern double   ChangeColorPct = 0.50;
extern color colorOver  = HotPink ;
extern color colorUnder = DimGray ;

//----
string OBJECT_PREFIX = "LEVELS";
int ObjectId = 0;


int n ;

color colorX, colorY, theColor ;

       double StartX  ;
       double StartY ;
       double EndX ;
       double EndY ;
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
//  ChangeColor = ChangeColor - 1 ;
//  colorX = color1 ; 
//  colorY = color2 ;
  
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CSH(int shift)
  {
//   return (MathMax(Open[shift], Close[shift]));
   return (MathMax(High[shift], Low[shift]));   
   
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CSL(int shift)
  {
//   return (MathMin(Open[shift],Close[shift]));
   return (MathMin(High[shift],Low[shift]));   
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string IntToStr(int X)
  {
    return (DoubleToStr(X, 0));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string ObGetUniqueName(string Prefix)
  {
   ObjectId++;
   return (Prefix+" "+IntToStr(ObjectId));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
   ObDeleteObjectsByPrefix(OBJECT_PREFIX);
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
  
   string S;
   ObDeleteObjectsByPrefix(OBJECT_PREFIX);
   double HH = -1;
   double LL = 999999;
   int History = MathMin(Bars,MAX_HISTORY);
   int i, j, k;
   
   for(i = 0; i < History; i++)
     {
       HH = MathMax(HH, High[i]);
       LL = MathMin(LL, Low[i]);
       
//       HH = MathMax(HH, CSH(i));
//       LL = MathMin(LL, CSL(i));       
       
     }
     
   int NumberOfPoints = (HH - LL) / (1.0*Point*STEP) + 1;
   int Count[];
   
   ArrayResize(Count, NumberOfPoints);
   
   for(i = 0; i < NumberOfPoints; i++) 
       Count[i] = 0;
       
   for(i = 1; i < History; i++)
     {
       double C = CSL(i);
       while(C < CSH(i))
         {
           int Index = (C-LL) / (1.0*Point*STEP);
           Count[Index]++;    
           C += 1.0*Point*STEP;
         }
     }
     
   n = 0 ;  
   int    maxValueIdx = ArrayMaximum(Count);
   int    xValue      = ChangeColorPct * Count[maxValueIdx] ;  
   
   
   for(i = 0; i < NumberOfPoints; i++)
     {
         StartX = Time[0]+SDVIG*Period()*60;        
         StartY = LL + (1.0*Point*STEP*i); 
         EndX   = (Time[0+Count[i]]+SDVIG*Period()*60);
         EndY   = StartY;
 string ObjName = ObGetUniqueName(OBJECT_PREFIX);
       
//       n = n + 1 ;
//       if( n > ChangeColor ) { theColor = colorX ; colorX = colorY ; colorY = theColor ; n = 0 ;}
       
       if( Count[i] > xValue ) { theColor = colorOver ; } else { theColor = colorUnder ; }
       
       ObjectDelete(ObjName);
       ObjectCreate(ObjName, OBJ_TREND, 0, StartX, StartY, EndX, EndY);
       ObjectSet(ObjName, OBJPROP_RAY, 0);
       ObjectSet(ObjName, OBJPROP_COLOR, theColor);
       ObjectSet(ObjName, OBJPROP_BACK, 1);
     }
     
     
  
     
   return(0);
  }
//+------------------------------------------------------------------+

/*

Comment( "iHH=" , DoubleToStr(HH,Digits)  , "\n" ,
         "LL=" ,DoubleToStr(LL,Digits)   ,  "\n" ,
         "STEP=" ,DoubleToStr(STEP,Digits)   ,  "\n" ,         
         "Point=" ,DoubleToStr(Point,6)   ,  "\n" ,           
         "1.0*Point*STEP*i=" ,DoubleToStr(1.0*Point*STEP*i,6)   ,  "\n" ,    
         "LL + 1.0*Point*STEP*i=" ,DoubleToStr(LL + 1.0*Point*STEP*i,Digits)   ,  "\n" ,                
         "StartY=" ,DoubleToStr(StartY,Digits)   ,  "\n" ,     
         "EndY=" ,DoubleToStr(EndY,Digits)   ,  "\n" ,        
         "StartX=" ,DoubleToStr(StartX,Digits)   ,  "\n" ,     
         "EndX=" ,DoubleToStr(EndX,Digits)   ,  "\n" ,                
                            
      ""     ) ;    
      
*/