//+------------------------------------------------------------------+ 
//|          TRO_BZ_Skyline                        TRO BUY ZONE .mq4 | 
//|                                                     Skyline,2008 | 
//|                                                                  | 
//+------------------------------------------------------------------+ 
#property copyright "Skyline,2008" 
#property link      "www.forexpertutti.it" 

#property indicator_chart_window 
#property  indicator_buffers 7 
#property  indicator_color1  White 
#property  indicator_color2  Blue 
#property  indicator_color3  Red 
#property  indicator_color4  Green 
#property  indicator_color5  Green 


extern bool   Show.PriceBox  = true ;
extern int    myBoxWidth     = 2;
extern bool   show.comment   = false ;

extern double myEntryTrigger   = 4 ;
extern double myProfitTarget   = 10 ;
extern double myStopLoss       = 7 ;

extern color colorOpen         = White ;
extern color colorTarget       = Green ;
extern color colorBuy          = Blue ;
extern color colorShort        = Red ;

double OpenLine[]; 
double BuyLine1[]; 
double BuyLine2[]; 
double SellLine1[]; 
double SellLine2[]; 
double TargetLine1[]; 
double TargetLine2[]; 

//+------------------------------------------------------------------+ 
string symbol, tChartPeriod,  tShortName ;  
int    digits2, digits, period, win ; 
double point;

//+------------------------------------------------------------------+ 
int init() 
  { 

   period       = Period() ;   
   tChartPeriod =  TimeFrameToString(period) ;  
   digits       =  Digits ;
   point        =  Point ; 
   symbol       =  Symbol() ; 
   tShortName = symbol + tChartPeriod  ; 
    
  if(digits == 5 || digits == 3) { digits2 = 0 ; point = point * 10 ; } else { digits2 = 0 ; }
    
  
//---- indicators 
   SetIndexStyle(0,DRAW_LINE,STYLE_DOT); 
   SetIndexBuffer(0,OpenLine); 
     
   SetIndexStyle(1,DRAW_LINE,STYLE_DASH); 
   SetIndexBuffer(1,BuyLine1);  

   SetIndexStyle(2,DRAW_LINE,STYLE_DASH); 
   SetIndexBuffer(2,SellLine1);  
      
   SetIndexStyle(3,DRAW_LINE,STYLE_DOT); 
   SetIndexBuffer(3,TargetLine1); 
    
   SetIndexStyle(4,DRAW_LINE,STYLE_DOT); 
   SetIndexBuffer(4,TargetLine2);      
//---- 
   return(0); 
  } 
  
//+------------------------------------------------------------------+ 

int deinit() 
  { 
   ObjectDelete(tShortName+"01"); 
   ObjectDelete(tShortName+"02"); 
   ObjectDelete(tShortName+"03"); 
   ObjectDelete(tShortName+"04");    
   ObjectDelete(tShortName+"05");    
   return(0); 
  } 
  
  
//+------------------------------------------------------------------+ 
int start() 
  { 
   int    counted_bars=IndicatorCounted(); 
   int limit; 
//---- 
   //---- last counted bar will be recounted 
   if(counted_bars>0) counted_bars--; 
    
   limit=Bars-counted_bars; 
    
   for (int i=0; i<limit; i++) 
   { 
    int BarShift   = iBarShift(NULL,PERIOD_H1,Time[i],true); 
    double OpenH1  = iOpen(NULL,PERIOD_H1,BarShift); 
    OpenLine[i]    = OpenH1; 
    BuyLine1[i]    = OpenH1+myEntryTrigger*point; 
//    BuyLine2[i]    = OpenH1+4*point; 
    SellLine1[i]   = OpenH1-myEntryTrigger*point; 
//    SellLine2[i]   = OpenH1-4*point; 
    TargetLine1[i] = OpenH1+myProfitTarget*point; 
    TargetLine2[i] = OpenH1-myProfitTarget*point;    
   } 

 


string tTime = TimeToStr(Time[0]) ;

   if(Show.PriceBox) { DoBox() ; }

if( show.comment )
{
Comment( "BuyZone..... ", tTime, "\n", 

         "LgTarget.... ", DoubleToStr(TargetLine1[0],digits) , "\n",  
         "LgTrigger... ", DoubleToStr(BuyLine1[0],digits) ,"\n", 
         "OpenLine.... ", DoubleToStr(OpenLine[0],digits) ,"\n",                   
         "ShTrigger... ", DoubleToStr(SellLine1[0],digits) , "\n",                  
         "ShTarget.... ", DoubleToStr(TargetLine2[0],digits) , "\n",    
//         "point.... ", DoubleToStr(point,digits) , "\n",             
         "") ;
}

   return(0); 
  }  
  
//+--------- TRO MODIFICATION ---------------------------------------+  
void DoBox()    
{

       if (ObjectFind(tShortName+"01") != 0)
      {
          ObjectCreate(tShortName+"01",OBJ_ARROW,0,Time[0],TargetLine1[0]);
          ObjectSet(tShortName+"01",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"01",OBJPROP_COLOR,colorTarget);  
          ObjectSet(tShortName+"01",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"01",0,Time[0],TargetLine1[0]);
         ObjectSet(tShortName+"01",OBJPROP_COLOR,colorTarget);  
      }

       if (ObjectFind(tShortName+"02") != 0)
      {
          ObjectCreate(tShortName+"02",OBJ_ARROW,0,Time[0],BuyLine1[0]);
          ObjectSet(tShortName+"02",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"02",OBJPROP_COLOR,colorBuy);  
          ObjectSet(tShortName+"02",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"02",0,Time[0],BuyLine1[0]);
         ObjectSet(tShortName+"02",OBJPROP_COLOR,colorBuy);  
      }

 
       if (ObjectFind(tShortName+"03") != 0)
      {
          ObjectCreate(tShortName+"03",OBJ_ARROW,0,Time[0],OpenLine[0]);
          ObjectSet(tShortName+"03",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"03",OBJPROP_COLOR,colorOpen);  
          ObjectSet(tShortName+"03",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"03",0,Time[0],OpenLine[0]);
         ObjectSet(tShortName+"03",OBJPROP_COLOR,colorOpen);  
      }
 
       if (ObjectFind(tShortName+"04") != 0)
      {
          ObjectCreate(tShortName+"04",OBJ_ARROW,0,Time[0],SellLine1[0]);
          ObjectSet(tShortName+"04",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"04",OBJPROP_COLOR,colorShort);  
          ObjectSet(tShortName+"04",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"04",0,Time[0],SellLine1[0]);
         ObjectSet(tShortName+"04",OBJPROP_COLOR,colorShort);  
      }

      
       if (ObjectFind(tShortName+"05") != 0)
      {
          ObjectCreate(tShortName+"05",OBJ_ARROW,0,Time[0],TargetLine2[0]);
          ObjectSet(tShortName+"05",OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShortName+"05",OBJPROP_COLOR,colorTarget);  
          ObjectSet(tShortName+"05",OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tShortName+"05",0,Time[0],TargetLine2[0]);
         ObjectSet(tShortName+"05",OBJPROP_COLOR,colorTarget);  
      }
                
   return(0);
}


//+--------- TRO MODIFICATION ---------------------------------------+  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}



//+--------- TRO MODIFICATION ---------------------------------------+  