//+------------------------------------------------------------------+ 
//|   TRO_RANGE_HISTOGRAM_LITE                                       | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
 
#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2

#property  indicator_color1  Blue
#property  indicator_color2  Magenta

extern int myCorner= 0;
extern int x.offset= 530 ;//250
extern int y.offset= 0 ;//-160

extern bool Show.Histogram = true ; 


extern string myFont       = "Arial Bold" ;
extern int    myFontSize   = 20 ;

extern int       myLineWidth = 3;
extern int    AlertTime = 5 ;
extern color  AlertTimeColor = Magenta ;

extern int myPctHi = 66 ;
extern int myPctLo = 34 ;

extern color myPctHiColor = Red ; 
extern color myPctMidColor = DimGray ; 
extern color myPctLoColor = Blue ; 

extern int    myThreshold = 50 ;
extern color myThresholdColor = Magenta ;

double     H_Buffer[];
double     L_Buffer[];

double spread, Pct, point, range ;
double s1[];


string symbol, tChartPeriod,  tShortName, sSpread, sOpen, sPrice, sHigh, sLow, sPct ;  
int    digits2, digits, period, win, xInc, yInc, xPos, yPos  ; 
 
string   tObjName01 , tObjName02 , tObjName03, tObjName04, tObjName05, tObjName06, tObjName07, tObjName08, tObjName09 ; 
string   tObjName10 ;
 
color colorPct, colorTime, colorPrice, colorHigh, colorLow ; 
 

 
//+------------------------------------------------------------------+
int init()
  {


   period       = Period() ;  
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;

   if(digits == 5 || digits == 3) { digits2 = 0 ; point = point * 10 ; } else { digits2 = 0 ; }

   tShortName = symbol + tChartPeriod  ; 


if(Show.Histogram)
{
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,myLineWidth);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,myLineWidth);
   SetLevelStyle(STYLE_DOT, 1, DimGray) ;
   SetLevelValue(1,100);
   SetLevelValue(2,90);   
   SetLevelValue(3,80);
   SetLevelValue(4,70);
   SetLevelValue(5,60);
   SetLevelValue(6,50);
   SetLevelValue(7,40);  
   SetLevelValue(8,30); 
   SetLevelValue(9,20);    
   SetLevelValue(10,10);        
}
else
{
   SetIndexStyle(0,DRAW_NONE);  
   SetIndexStyle(1,DRAW_NONE); 
}

   SetIndexBuffer(0,H_Buffer);
   SetIndexBuffer(1,L_Buffer);
   
   IndicatorShortName("HL_Histogram");
   
   SetIndexLabel(0,"HiOp");
   SetIndexLabel(1,"OpLo");

 

   tObjName01 =   tShortName   + "hl01";
   tObjName02 =   tShortName   + "hl02";
   tObjName03 =   tShortName   + "hl03";
   tObjName04 =   tShortName   + "hl04";
   tObjName05 =   tShortName   + "hl05";
   tObjName06 =   tShortName   + "hl06";
   tObjName07 =   tShortName   + "hl07";
   tObjName08 =   tShortName   + "hl08";
   tObjName09 =   tShortName   + "hl09";
   tObjName10 =   tShortName   + "hl10";
      
   IndicatorShortName(tShortName);  
   

   
   return(0);
  }


//+------------------------------------------------------------------+  
int deinit()
  {
   ObjectsDeleteAll(win);   
   return(0);
  }  
   
  
//+------------------------------------------------------------------+


int start()
  {
   
   win =    WindowFind(tShortName);
   ObjectsDeleteAll(win); 
           
   int limit;
   int counted_bars=IndicatorCounted();
 
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   for(int i=0; i<limit; i++)
   {
  
      H_Buffer[i] = (High[i] - Low[i]) / point ;
      if( H_Buffer[i] > myThreshold ) { L_Buffer[i] = H_Buffer[i] ; }

   }

 
   
   return(0);
  }

//+------------------------------------------------------------------+ 

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
//+------------------------------------------------------------------+
  